// Generated by ReScript, PLEASE EDIT WITH CARE

import * as Path from "path";
import * as Dict$Std from "@prefix_re/std/lib/es6/src/Dict.js";
import * as Path$Std from "@prefix_re/std/lib/es6/src/Deno/Path.js";
import * as Yaml$Std from "@prefix_re/std/lib/es6/src/Deno/Yaml.js";
import * as Array$Std from "@prefix_re/std/lib/es6/src/Array.js";
import * as Float$Std from "@prefix_re/std/lib/es6/src/Float.js";
import * as String$Std from "@prefix_re/std/lib/es6/src/String.js";
import * as Caml_option from "rescript/lib/es6/caml_option.js";

function parseMode(str) {
  if (str === "docker") {
    return "docker";
  } else {
    return "command";
  }
}

function modeToString(mode) {
  if (mode === "docker") {
    return "docker";
  } else {
    return "command";
  }
}

function create($$int, folderPath) {
  var name = Yaml$Std.get($$int, "name");
  var name$1;
  name$1 = typeof name === "number" || name.TAG !== /* String */0 ? Path.basename(folderPath) : name._0;
  var match = Yaml$Std.get($$int, "version");
  var match$1 = Deno.env.get("CI_COMMIT_SHA");
  var version;
  if (typeof match === "number") {
    version = (match$1 == null) ? "0.0.0" : match$1;
  } else {
    switch (match.TAG | 0) {
      case /* String */0 :
          version = match._0;
          break;
      case /* Number */1 :
          version = Float$Std.toString(match._0);
          break;
      default:
        version = (match$1 == null) ? "0.0.0" : match$1;
    }
  }
  var version$1 = String$Std.slice(version, 0, 50);
  var folder = Yaml$Std.get($$int, "folder");
  var folder$1;
  folder$1 = typeof folder === "number" || folder.TAG !== /* String */0 ? folderPath : Path.join(folderPath, folder._0);
  var mode = Yaml$Std.get($$int, "mode");
  var mode$1;
  var exit = 0;
  if (typeof mode === "number" || mode.TAG !== /* String */0) {
    exit = 1;
  } else {
    mode$1 = parseMode(mode._0);
  }
  if (exit === 1) {
    mode$1 = Array$Std.some(Path$Std.read(folder$1), (function (file) {
            return String$Std.includes(file.name, "Dockerfile");
          })) ? "docker" : "command";
  }
  var modeInt = mode$1 === "docker" ? Yaml$Std.get($$int, "docker") : /* Null */0;
  var commit = Yaml$Std.get($$int, "commit");
  var commit$1;
  commit$1 = typeof commit === "number" || commit.TAG !== /* String */0 ? Caml_option.nullable_to_opt(Deno.env.get("CI_COMMIT_SHA")) : commit._0;
  var branch = Yaml$Std.get($$int, "branch");
  var branch$1;
  branch$1 = typeof branch === "number" || branch.TAG !== /* String */0 ? Caml_option.nullable_to_opt(Deno.env.get("CI_COMMIT_REF_NAME")) : branch._0;
  var reqs = Yaml$Std.get($$int, "reqs");
  var reqs$1;
  if (typeof reqs === "number") {
    reqs$1 = [];
  } else {
    switch (reqs.TAG | 0) {
      case /* String */0 :
          reqs$1 = [reqs._0];
          break;
      case /* Array */3 :
          reqs$1 = Array$Std.reduce(reqs._0, (function (reqs, req) {
                  if (typeof req === "number") {
                    return [];
                  } else if (req.TAG === /* String */0) {
                    return Array$Std.concat(reqs, [req._0]);
                  } else {
                    return [];
                  }
                }), []);
          break;
      default:
        reqs$1 = [];
    }
  }
  var trigger = Yaml$Std.get($$int, "trigger");
  var trigger$1;
  if (typeof trigger === "number") {
    trigger$1 = [];
  } else {
    switch (trigger.TAG | 0) {
      case /* String */0 :
          trigger$1 = [trigger._0];
          break;
      case /* Array */3 :
          trigger$1 = Array$Std.reduce(trigger._0, (function (ints, $$int) {
                  if (typeof $$int === "number") {
                    return [];
                  } else if ($$int.TAG === /* String */0) {
                    return Array$Std.concat(ints, [$$int._0]);
                  } else {
                    return [];
                  }
                }), []);
          break;
      default:
        trigger$1 = [];
    }
  }
  var bool = Yaml$Std.get($$int, "bootstrap");
  var bootstrap;
  bootstrap = typeof bool === "number" || bool.TAG !== /* Bool */4 ? false : bool._0;
  var manual = Yaml$Std.get($$int, "manual");
  var manual$1;
  manual$1 = typeof manual === "number" || manual.TAG !== /* Bool */4 ? undefined : manual._0;
  var image = Yaml$Std.get($$int, "image");
  var image$1;
  image$1 = typeof image === "number" || image.TAG !== /* String */0 ? undefined : image._0;
  var tags = Yaml$Std.get($$int, "tags");
  var tags$1;
  tags$1 = typeof tags === "number" ? [] : (
      tags.TAG === /* Array */3 ? Array$Std.reduce(tags._0, (function (tags, tag) {
                if (typeof tag === "number") {
                  return [];
                } else if (tag.TAG === /* String */0) {
                  return Array$Std.concat(tags, [tag._0]);
                } else {
                  return [];
                }
              }), []) : []
    );
  var profiles = Yaml$Std.get($$int, "profiles");
  var profiles$1;
  profiles$1 = typeof profiles === "number" ? [
      "linux-x86_64",
      "linux-armv8"
    ] : (
      profiles.TAG === /* Array */3 ? Array$Std.reduce(profiles._0, (function (array, profile) {
                if (typeof profile === "number" || profile.TAG !== /* String */0) {
                  return array;
                } else {
                  return Array$Std.concat(array, [profile._0]);
                }
              }), []) : [
          "linux-x86_64",
          "linux-armv8"
        ]
    );
  var cmds = Yaml$Std.get($$int, "before_script");
  var beforeScript;
  if (typeof cmds === "number") {
    beforeScript = [];
  } else {
    switch (cmds.TAG | 0) {
      case /* String */0 :
          beforeScript = [cmds._0];
          break;
      case /* Array */3 :
          beforeScript = Array$Std.reduce(cmds._0, (function (cmds, cmd) {
                  if (typeof cmd === "number") {
                    return [];
                  } else if (cmd.TAG === /* String */0) {
                    return Array$Std.concat(cmds, [cmd._0]);
                  } else {
                    return [];
                  }
                }), []);
          break;
      default:
        beforeScript = [];
    }
  }
  var cmds$1 = Yaml$Std.get($$int, "script");
  var script;
  if (typeof cmds$1 === "number") {
    script = [];
  } else {
    switch (cmds$1.TAG | 0) {
      case /* String */0 :
          script = [cmds$1._0];
          break;
      case /* Array */3 :
          script = Array$Std.reduce(cmds$1._0, (function (cmds, cmd) {
                  if (typeof cmd === "number") {
                    return [];
                  } else if (cmd.TAG === /* String */0) {
                    return Array$Std.concat(cmds, [cmd._0]);
                  } else {
                    return [];
                  }
                }), []);
          break;
      default:
        script = [];
    }
  }
  var cmds$2 = Yaml$Std.get($$int, "after_script");
  var afterScript;
  if (typeof cmds$2 === "number") {
    afterScript = [];
  } else {
    switch (cmds$2.TAG | 0) {
      case /* String */0 :
          afterScript = [cmds$2._0];
          break;
      case /* Array */3 :
          afterScript = Array$Std.reduce(cmds$2._0, (function (cmds, cmd) {
                  if (typeof cmd === "number") {
                    return [];
                  } else if (cmd.TAG === /* String */0) {
                    return Array$Std.concat(cmds, [cmd._0]);
                  } else {
                    return [];
                  }
                }), []);
          break;
      default:
        afterScript = [];
    }
  }
  var cache = Yaml$Std.get($$int, "cache");
  var match$2 = Yaml$Std.get(cache, "key");
  var match$3 = Yaml$Std.get(cache, "paths");
  var cache$1;
  var exit$1 = 0;
  if (typeof match$2 === "number" || match$2.TAG !== /* String */0) {
    exit$1 = 1;
  } else if (typeof match$3 === "number" || match$3.TAG !== /* Array */3) {
    cache$1 = undefined;
  } else {
    var paths = Array$Std.reduce(match$3._0, (function (paths, path) {
            if (typeof path === "number") {
              return [];
            } else if (path.TAG === /* String */0) {
              return Array$Std.concat(paths, [Path.join(folder$1, path._0)]);
            } else {
              return [];
            }
          }), []);
    cache$1 = {
      key: match$2._0,
      paths: paths
    };
  }
  if (exit$1 === 1) {
    if (typeof match$3 === "number" || match$3.TAG !== /* Array */3) {
      cache$1 = undefined;
    } else {
      var paths$1 = Array$Std.reduce(match$3._0, (function (paths, path) {
              if (typeof path === "number") {
                return [];
              } else if (path.TAG === /* String */0) {
                return Array$Std.concat(paths, [Path.join(folder$1, path._0)]);
              } else {
                return [];
              }
            }), []);
      cache$1 = {
        key: undefined,
        paths: paths$1
      };
    }
  }
  var rules = Yaml$Std.get($$int, "rules");
  var rules$1;
  if (typeof rules === "number" || rules.TAG !== /* Array */3) {
    rules$1 = undefined;
  } else {
    var array = Array$Std.reduce(rules._0, (function (rulesAcc, rule) {
            var match = Yaml$Std.get(rule, "if");
            var match$1 = Yaml$Std.get(rule, "when");
            if (typeof match === "number") {
              return [];
            }
            if (match.TAG !== /* String */0) {
              return [];
            }
            var entryIf = match._0;
            if (typeof match$1 !== "number" && match$1.TAG === /* String */0) {
              return Array$Std.concat(rulesAcc, [{
                            if: entryIf,
                            when: match$1._0
                          }]);
            }
            return Array$Std.concat(rulesAcc, [{
                          if: entryIf,
                          when: undefined
                        }]);
          }), []);
    rules$1 = Array$Std.length(array) >= 0 ? array : undefined;
  }
  var sets = Yaml$Std.get($$int, "variables");
  var variables;
  variables = typeof sets === "number" || sets.TAG !== /* Object */2 ? Dict$Std.empty(undefined) : Dict$Std.fromArray(Array$Std.reduce(Dict$Std.toArray(sets._0), (function (elems, param) {
                var val = param[1];
                if (typeof val === "number" || val.TAG !== /* String */0) {
                  return elems;
                } else {
                  return Array$Std.concat(elems, [[
                                param[0],
                                val._0
                              ]]);
                }
              }), []));
  return {
          name: name$1,
          version: version$1,
          folder: folder$1,
          mode: mode$1,
          modeInt: modeInt,
          commit: commit$1,
          branch: branch$1,
          needs: reqs$1,
          trigger: trigger$1,
          bootstrap: bootstrap,
          profiles: profiles$1,
          beforeScript: beforeScript,
          script: script,
          afterScript: afterScript,
          image: image$1,
          tags: tags$1,
          cache: cache$1,
          manual: manual$1,
          rules: rules$1,
          variables: variables,
          interruptible: false
        };
}

export {
  parseMode ,
  modeToString ,
  create ,
  
}
/* path Not a pure module */
